	PAGE	88,132
	TITLE	DLINE -- EGAD Screen Print (c) 1993 LS Software
	SUBTTL	Draw a Line (used in Crop Box adjustment)
;
;	EGAD Screen Print
;
;	COPYRIGHT (C) 1988-1990, 1993 LS Software
;
;
; SUBROUTINE DLINE (StartX, StartY, EndX, EndY, Color)
; ----------------------------------------------------------
; PURPOSE
; =======
;   Draws a line from StartX, StartY to EndX, EndY in graphics mode.
;
; OTHER SUBROUTINES CALLED
; ========================
;   PLOTPT		: Plots a single point
;
; INPUT VARIABLES
; ===============
;	
;   StartX    -I-       : Starting X-Position to be plotted.
;   StartY    -I-       : Starting Y-Position to be plotted.
;   EndX      -I-       : Ending   X-Position to be plotted.
;   EndY      -I-       : Ending   Y-Position to be plotted.
;   Color     -I-       : Color to draw line in.

; OUTPUT VARIABLES
; ================
;   None
;
; NOTES
; =====
;   Coordinates into the subroutine are:      1,1,MaxX,MaxY
;   The routine converts to DOS's format of:  0,0,MaxX-1,MaxY-1
;
; -------------------------------------
; written by 
; Version 1.0
; Date of Creation:
; Date Last Modified:
; -------------------------------------
;
; --------- P U B L I C    D E C L A R A T I O N S ---------
;
;	.MODEL	SMALL
;
        PUBLIC  DLINE

INCLUDE	GLOBAL.INC

_DATA		SEGMENT WORD PUBLIC 'DATA'
	EXTRN	VIDEO_MODE:BYTE
_DATA		ENDS

	EXTRN	PLOTPT:PROC, RESET:PROC, GET_MODE_PTR:PROC
;
; ------------------ D A T A    A R E A --------------------
;
_DATA	SEGMENT
;
; ------------------ C O D E    A R E A --------------------

; -------------------- E Q U A T E S -----------------------

StartX	equ  <word ptr 4[BP]>
StartY	equ  <word ptr 6[BP]>
EndX	equ  <word ptr 8[BP]>
EndY	equ  <word ptr 10[BP]>
Colour	equ  <word ptr 12[BP]>

; ---------------- M A I N    P R O G R A M ----------------
_DATA	ENDS

_TEXT	SEGMENT
	ASSUME	CS:_TEXT,DS:_DATA,SS:STACK,ES:_DATA
;
; Draws horizontal or vertical line from x1,y1 to x2,y2
;
; INPUTS:
;		StartX, StartY, EndX, EndY, Color (on stack)
; RETURNS:	none
; USES:		AX, BX, CX
DLINE PROC NEAR

        push    BP             ; Save registers
        mov     BP,SP
        push    SI
; Do nothing in text modes
	call	get_mode_ptr	; returns CL = mode flags
	test	cl,vm_text
	jnz	exit
	mov	cx,colour
; Check for vertical line
        mov     dx,StartY	; Starting &
	mov	si,EndY		;  Ending Y coordinates
	cmp	dx,si
	jne	do_vert
; Assume horizontal line
DO_HORIZ:
	mov	dx,StartX	; Place to start X
	mov	si,EndX 	; Place to end X
sh1:
	cmp	dx,si
	jg	finish
	mov	ax,dx
	mov	bx,StartY
	call	near ptr plotpt
	inc	dx
	jmp	sh1

DO_VERT:
	; Make vertical lines 2 pixels shorter
	; (1 each @ top & bottom)
	inc	dx		; Increment StartY
	dec	si		; Decrement EndY
sv1:
	cmp	dx,si
	jg	finish
	mov	ax,StartX
	mov	bx,dx
	call	near ptr plotpt
	inc	dx
	jmp	sv1

FINISH:
	CALL	RESET
EXIT:
        pop     SI
        pop     BP

        retn	5*2

; ----------------------------------------------------------

DLINE	endp

; ---------------- E N D   P R O G R A M -------------------

; ------------- E N D    C O D E    A R E A ----------------

_TEXT	ENDS
        END
