; ********************************************
; DRIVERS FOR:
;
; Dataproducts 8050
; Paper Tiger
; ********************************************
; 

	PRN_GR	 EQU GR_QUO
	GR_QUOTE EQU 3			; Command character to quote
	prn_chrset	= chrset_ascii7	; Standard PC-8 -> ASCII
	prn_byte	= byte_vert

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   2,  0,     200, 80, 105
	GFXMAP 1,  0,   1,  0,     200, 80, 105
	GFXMAP 2,  0,   1,  0,       5, 80, 105
	GFXMAP 3,  0,   1,  1,       7, 80, 105
	GFXMAP 4,  0,   1,  1,       7, 80, 105
	GFXMAP X,  0,   1,  1,       7, 80, 105
	; alternates
	GFXMAP 10, 0,   2,  1,       4, 80, 105
	GFXMAP 11, 0,   3,  1,       6, 80, 105
	GFXMAP 12, 0,   1,  1,       9, 80, 105
	GFXMAP 13, 0,   1,  0,       7, 80, 105
	GFXMAP 14, 0,   1,  0,       7, 80, 105
	GFXMAP 1X, 0,   1,  0,       7, 80, 105
	gfxmap_end label word

 IF (prn_mdl eq MDL_DPTIGER)
	GMODES	LABEL	WORD
		PRNMODE	0, 84, 84
	MAXMODE	EQU	0

	PMODE_PRT0	DW	0	; resolution set when gfx mode entered
	PMODE_LEN0	DW	?	; (Length put here, but ignored)

	EGADSTR GSETUP,<13,10,27,'C,4,$',2,29,3>
		; CR/LF		to start empty line,
		; Esc C,4,$	sets 1/12" (vert advance 2)
		; 2		normal print
		; 29		10 cpi
		; 3		graphics mode

	GR_OFF	DW	0		; Graphics remain on during printing

	EGADSTR MLCRLF,<3,14>		; 7 dot vertical advance (microline cr/lf)

	EGADSTR NSPACE,<3,2,13>		; Reset-printer code after graphics
					; Exit Graphics	mode; CR
 ELSE
	GMODES	LABEL	WORD
		PRNMODE	0, 84, 84
	MAXMODE	EQU	0

	EGADSTR PMODE_PRT0,<27,'x,0,$',3> ; 84x84 graphics mode
	PMODE_LEN0	DW	?	; (Length put here, but ignored)

	EGADSTR GSETUP,<27,'x,0,$',27,'j,0,$',27,'C,4,$',2,29,13,10>
		; 27,'x,0,$'	; Set 84x84 dpi graphics
		; 27,'j,0,$'	; use 1/48" vertical increments
		; 27,'C,4,$'	; 1/12"	vertical advance 2
		; 2		; Normal print mode
		; 29		; Normal 10 cpi
		; 13,10		; CR/LF

	EGADSTR GR_OFF,<3,2,13>		; Exit Graphics	mode; do Carriage Return
	EGADSTR MLCRLF,<20>		; 7 dot vertical advance (microline cr/lf)
	NSPACE	DW	0		; Reset-printer code after graphics

	NBUFFERS EQU 4
	GR_YELLOW LABEL WORD
	YELLOW	DW	6
		DB	27,'Q,1,$'	; Select yellow ribbon
	GR_MAGENTA LABEL WORD
	MAGENTA	DW	6
		DB	27,'Q,2,$'	; Select magenta ribbon
	GR_CYAN LABEL WORD
	CYAN	DW	6
		DB	27,'Q,3,$'	; Select cyan ribbon
	GR_BLACK LABEL WORD
	BLACK	DW	6
		DB	27,'Q,4,$'	; Select black ribbon
 ENDIF

	EGADSTR CR,<27,'G,0,$'>		; Carriage return, no line feed
	EGADSTR CRLF,<13,10>

	; Patterns: Based on 7 printer pixels per pass
	;	Dataproducts uses LSB on top

	PATTERN 200, 3, 7
		db	00000011b
		db	00011100b
		db	01100000b
	PATTERN 4, 4, 7
		db	00000011b
		db	00001100b
		db	00010000b
		db	01100000b
	PATTERN 5, 5, 7
		db	00000001b
		db	00000110b
		db	00001000b
		db	00110000b
		db	01000000b
	PATTERN 6, 6, 7
		db	00000001b
		db	00000110b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
	PATTERN	7, 7, 7
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
	PATTERN	9, 9, 7
		db	00000001b
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	0		; end of patterns

	;	640 Bytes across the page, plus two bytes of length
	BUFLEN	EQU	642

	DITHER_LEVELS	EQU 2			; 2 dither levels (ON/OFF only)
	DITHER_WIDTH	EQU 2			; 2 bytes/level
	NDITHERS	EQU 1			; 1 dither table

	DITHER_TABLE LABEL WORD
		DB	0,0
		DB	0FFH,0FFH

 IF (prn_typ and typ_color)
	color_xlat label byte
		db	000h,001h,001h,001h,002h,003h,003h,003h
		db	002h,003h,003h,003h,002h,003h,003h,003h
		db	004h,005h,005h,005h,006h,007h,001h,001h
		db	006h,002h,003h,003h,006h,002h,003h,003h
		db	004h,005h,005h,005h,006h,004h,005h,005h
		db	006h,006h,007h,007h,006h,006h,007h,007h
		db	004h,005h,005h,005h,006h,004h,005h,005h
		db	006h,006h,007h,007h,006h,006h,007h,007h
 ELSE
	color_xlat label byte
		db	0,1,1,1,1,1,1,1
 ENDIF

	; End of Dataproducts / Paper Tiger code

