; ********************************************
; DRIVERS FOR:
;
; Epson 9-pin (Epson models "below" LQ series)
; Star Micronics 9-pin (use Epson designation)
; IBM ProPrinter II
; ********************************************
; 
	prn_byte	= byte_vert
	prn_gr		= gr_bin

	;	Graphics Mode definitions.
	;
  IF ((PRN_MFG EQ MFG_EPSON) AND (PRN_MDL EQ MDL_EPMX))
	SHOWIT	<Graphic Setup>,<Epson MX/120 dpi>
	prn_chrset = chrset_ascii7
	; Old MX-80 (120 dpi only)
	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	; Primary "Old" Epson modes:
	GFXMAP 0,  0,   3,  0,     200, P_WID, 105 ; 320x200
	GFXMAP 1,  0,   1,  0,       6, P_WID, 105 ; 640x200
	GFXMAP 2,  0,   2,  1,       9, P_WID, 105 ; 640x350
	GFXMAP 3,  0,   2,  1,       7, P_WID, 105 ; 640x480
	GFXMAP 4,  0,   2,  1,      10, P_WID, 105 ; 720x348
	GFXMAP X,  0,   1,  0,      13, P_WID, 105
	; Alternate modes:
	GFXMAP 10, 0,   2,  1,       8, P_WID, 105 ; 320x200, 3.33x4.44" (rot.)
	GFXMAP 11, 0,   3,  1,      10, P_WID, 105 ; 640x200, 5x7.1" (rot.)
	GFXMAP 12, 0,   1,  0,      10, P_WID, 105 ; 640x350, 5.3 x 3.9"
	GFXMAP 13, 0,   1,  0,      13, P_WID, 105 ; 640x480, 5.3 x 4.1"
	GFXMAP 14, 0,   1,  0,       9, P_WID, 105 ; 720x348, 6 x 4.8" (rot.)
	GFXMAP 1X, 0,   1,  1,      13, P_WID, 105
  ELSE
    IF (PRN_TYP AND TYP_MAT24) EQ TYP_MAT24
    ; 24-Pin Printer (in 9-pin emulation) with 240x60 dpi graphics
    ; (e.g., ProPrinter with AGM *ON*)
	SHOWIT	<Graphic Setup>,<Epson 24-pin printer using 8-pin graphics>
	prn_chrset = chrset_pc8
	; Landscape 24 - pin
	GFXMAP 0,  0,   2,  1,      10, P_WID, 105 ; 320x200
	GFXMAP 1,  0,   3,  1,      11, P_WID, 105 ; 640x200
	GFXMAP 2,  0,   2,  1,      11, P_WID, 105 ; 640x350
	GFXMAP 3,  1,   3,  1,      11, P_WID, 105 ; 640x480
	GFXMAP 4,  0,   2,  1,      11, P_WID, 105 ; 720x348
	GFXMAP X,  1,   2,  0,      13, P_WID, 105 ; Reduction
	; Portrait 24 - pin
	GFXMAP 10, 1,   3,  0,       9, P_WID, 105 ; 320x200
	GFXMAP 11, 0,   1,  0,       7, P_WID, 105 ; 640x200
	GFXMAP 12, 1,   3,  0,       8, P_WID, 105 ; 640x350
	GFXMAP 13, 1,   3,  0,      11, P_WID, 105 ; 640x480
	GFXMAP 14, 0,   1,  0,      10, P_WID, 105 ; 720x348
	GFXMAP 1X, 1,   2,  1,      13, P_WID, 105 ; Reduction
    ELSE
    ; 9-Pin Printer with 240x72 dpi graphics capability
    ; -or- 24-Pin Printer emulating 9-pin printer with 20-pin
    ;	graphics mode (e.g., ProPrinter with AGM *OFF*)
	SHOWIT	<Graphic Setup>,<Epson 9-pin printer, or ProPrinter with AGM OFF>
	prn_chrset = chrset_pc8
	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	; NORMAL (Best Ratio) Epson Modes:
	GFXMAP 0,  0,   3,  0,     200, P_WID, 105 ; 320x200, 8x5.6"
	GFXMAP 1,  0,   1,  0,       6, P_WID, 105 ; 640x200
	GFXMAP 2,  0,   2,  1,       9, P_WID, 105 ; 640x350, 5.8x7.9" (rot.)
	GFXMAP 3,  1,   3,  0,       9, P_WID, 105 ; 640x480, 8x5.9"
	GFXMAP 4,  0,   2,  1,      10, P_WID, 105 ; 720x348, 5.8x8" (rot.)
	GFXMAP X,  1,   2,  0,      13, P_WID, 105 ; Reduction
	; Alternate Epson modes:
	GFXMAP 10, 0,   2,  1,       8, P_WID, 105	; 320x200, 3.33x4.44" (rot.)
	GFXMAP 11, 0,   3,  1,      10, P_WID, 105	; 640x200, 5x7.1" (rot.)
	GFXMAP 12, 1,   2,  0,      10, P_WID, 105	; 640x350, 5.3x3.9"
	GFXMAP 13, 1,   3,  1,       9, P_WID, 105	; 640x480, 6x7.9" (rot.)
	GFXMAP 14, 1,   2,  0,       9, P_WID, 105 ; 720x348, 6x4.3"
	GFXMAP 1X, 1,   2,  1,      13, P_WID, 105	; Reduction
    ENDIF
  ENDIF
	gfxmap_end label word

	GMODES	LABEL	WORD
  IF (PRN_TYP AND TYP_MAT24) EQ TYP_MAT24
		PRNMODE 0, 120, 60	; 9-pin emulation
		PRNMODE 1, 240, 60
  ELSE
		PRNMODE	0, 120, 72	; Standard 9-pin
		PRNMODE	1, 240, 72
  ENDIF
	MAXMODE	EQU	1

	PMODE_PRT0	DW 4
			DB	27,'L'
	PMODE_LEN0	DW	?	; Length goes here

	PMODE_PRT1	DW 4
	IF (prn_mdl eq MDL_EPST)	; Star Gemini/SG/SD/SR series
			DB	27,'z'
	ELSE
			DB	27,'Z'
	ENDIF
	PMODE_LEN1	DW	?	; Length goes here

	EGADSTR GR_OFF,<13>		; Sent after each ribbon
	EGADSTR	CR,<13>			; CR only
	MLCRLF LABEL WORD		; Print after each graphics command
	EGADSTR CRLF,<13,10>

  IF ((PRN_TYP AND TYP_MAT24) EQ TYP_MAT24) OR ((PRN_MFG EQ MFG_IBM) AND (PRN_MDL EQ MDL_IBMPP))
	; For 24-pin printers, and IBM ProPrinter, which can print codes < 32
	; with a special escape sequence.
	EGADSTR QUOTE_CHAR,<27,'^'>
  ENDIF
	; Turn off condensed type and double-width:
	EGADSTR EXT_CHARS,<18,27,'W',0>
  IF (PRN_TYP AND TYP_MAT24) EQ TYP_MAT24
	; Set printer to graphics spacing.
	; NOTE:
	; - Epson LQ, Esc-A sets n/60"
	; - ProPrinter, Esc-A sets n/72"
	; That's why we use Esc-3.
	; (Also turn on pseudo-8-bit mode if possible)
	EGADSTR GSETUP,<27,'3',24,27,'y',1>
	; Reset printer to 1/6" spacing:
	EGADSTR NSPACE,<27,'A',12,27,'2'>
 ELSE
	; Set printer to graphics spacing:
	EGADSTR GSETUP,<27,'A',8,27,'2',27,'A',8>
	; Reset printer to 1/6" spacing:
	EGADSTR NSPACE,<27,'A',12,27,'2'>
 ENDIF

 IF (PRN_TYP AND TYP_COLOR)
	NBUFFERS EQU 4
	YELLOW LABEL WORD
	EGADSTR GR_YELLOW, <27,'r',4>	; Select yellow ribbon
	MAGENTA LABEL WORD
	EGADSTR GR_MAGENTA,<27,'r',1>	; Select magenta ribbon
	CYAN LABEL WORD
	EGADSTR GR_CYAN,   <27,'r',2>	; Select cyan ribbon
	BLACK LABEL WORD
	EGADSTR GR_BLACK,  <27,'r',0>	; Select black ribbon
 ELSE
	;	Text mode, Attribute definitions.  Not for color printers.

	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_emph	; 1
		DW	text_edbl	; 2
		DW	text_nlq	; 3

	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1 ; normally 3

	; Note! Don't try to use Esc-4 and Esc-5 for Italics.
	; IBM ProPrinters don't recognize them!!! (They use those
	; codes for other purposes!!!) -- wl 10/01/93
	EGADSTR TEXT_NOR, <27,'x',0,27,'F',27,'H',27,'-',0> ; NLQ off, emph off, dbl off
	EGADSTR TEXT_EMPH,<27,'E'>		   ; emph ON
  IF ((PRN_MFG EQ MFG_EPSON) AND (PRN_MDL EQ MDL_EPMX))
	EGADSTR TEXT_EDBL,<27,'E',27,'G'>	   ; emph ON , dbl ON
  ELSE
	EGADSTR TEXT_EDBL,<27,'-',1>		   ; underline ON
  ENDIF
	EGADSTR TEXT_NLQ, <27,'x',1>		   ; NLQ ON , emph off, dbl off
 ENDIF

	;	Up to 1920 Bytes across the page, plus two bytes of length
	; BUFLEN = 1922
	BUFLEN	=	P_WID * ((240 + 9)/ 10) + 2
	; Add 9 before dividing to round up.
	; BUFLEN	EQU	(P_WID * 240((RESX1 + 9) / 10)) + 2
	SHOWIT	<BUFLEN>,%(BUFLEN)

	;	Epson/Star bits are MSB on top
	PATTERN 200, 4, 8		; 4 Screen Lines per Print Row
		db	11000000b
		db	00110000b
		db	00001100b
		db	00000011b
	PATTERN 5, 5, 8
		db	11000000b
		db	001000000b
		db	00011000b
		db	00000100b
		db	00000011b
	PATTERN 6, 6, 8
		db	11000000b
		db	00100000b
		db	00010000b
		db	00001100b
		db	00000010b
		db	00000001b
	PATTERN 7, 7, 8
		db	10000000b
		db	01000000b
		db	00100000b
		db	00011000b
		db	00000100b
		db	00000010b
		db	00000001b
	PATTERN 8, 8, 8
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
	PATTERN 9, 9, 8
		db	10000000b
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
	PATTERN 10, 10, 8
		db	10000000b
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
	PATTERN 11, 11, 8
		db	10000000b
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000100b
		db	00000010b
		db	00000001b
	PATTERN 13, 13, 8
		db	10000000b
		db	10000000b
		db	01000000b
		db	00100000b
		db	00100000b
		db	00010000b
		db	00010000b
		db	00001000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000010b
		db	00000001b
		db	0		; end of patterns

  IF (PRN_TYP AND TYP_COLOR)	; Color printers:
	DITHER_LEVELS	EQU 4			; # of dither patterns
	DITHER_WIDTH	EQU 8			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither table

	; Entries in this table are taken from 8-level table below

	DITHER_TABLE LABEL WORD
	 DB	   0,   0,   0,   0,   0,   0,   0,   0	; 0-Level Dither
	 DB	0AAH,   0,055H,   0,0AAH,   0,055H,   0 ; 2-
	 DB	0FFH,   0,0AAH,055H,0FFH,   0,0AAH,055H ; 4-
	 DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH	; 7

	; Translate abstract colors	(--yymmcc)
	;    to physical ones		(kkccmmyy)
	COLOR_XLAT LABEL BYTE
		db	000h,010h,020h,030h,004h,014h,024h,034h
		db	008h,018h,028h,038h,00Ch,01Ch,02Ch,03Ch
		db	001h,011h,021h,031h,005h,040h,025h,035h
		db	009h,019h,029h,039h,00Dh,01Dh,02Dh,03Dh
		db	002h,012h,022h,032h,006h,016h,026h,036h
		db	00Ah,01Ah,080h,03Ah,00Eh,01Eh,02Eh,03Eh
		db	003h,013h,023h,033h,007h,017h,027h,037h
		db	00Bh,01Bh,02Bh,03Bh,00Fh,01Fh,02Fh,0C0h
  ELSE
	DITHER_LEVELS	EQU 8			; # of dither patterns
	DITHER_WIDTH	EQU 8			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither table

	DITHER_TABLE LABEL WORD
	 DB	   0,   0,   0,   0,   0,   0,   0,   0	; 0-Level Dither
	 DB	0AAH,   0,   0,   0,055H,   0,   0,   0 ; 1-
	 DB	0AAH,   0,055H,   0,0AAH,   0,055H,   0 ; 2-
	 DB	0AAH,0AAH,   0,055H,0AAH,0AAH,   0,055H ; 3-
	 DB	0FFH,   0,0AAH,055H,0FFH,   0,0AAH,055H ; 4-
	 DB	0AAH,055H,0AAH,055H,0AAH,055H,0AAH,055H ; 5-
	 DB	0FFH,0AAH,055H,0FFH,0FFH,0AAH,055H,0FFH ; 6-
	 DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH	; 7-
  ENDIF ; End of B&W Printer 8-Color

	; End of Epson code
