; ********************************************
; DRIVERS FOR:
;
; NEC-8023
; C. Itoh 8510
; ********************************************
; 

	PRN_GR		= GR_DEC
	GR_DEC_DIGITS	= 4
	prn_chrset	= chrset_other
	prn_byte	= byte_vert

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   2,  0,     200, 80, 105
	GFXMAP 1,  0,   1,  0,     200, 80, 105
	GFXMAP 2,  1,   3,  1,     350, 80, 105
	GFXMAP 3,  1,   2,  1,     350, 80, 105
	GFXMAP 4,  1,   1,  0,     350, 80, 105
	GFXMAP X,  1,   2,  0,       9, 80, 105
	; Alternate modes
	GFXMAP 10, 1,   3,  1,       7, 80, 105
	GFXMAP 11, 0,   3,  1,       7, 80, 105
	GFXMAP 12, 1,   2,  0,       6, 80, 105
	GFXMAP 13, 1,   2,  0,       9, 80, 105
	GFXMAP 14, 1,   1,  0,     350, 80, 105
	GFXMAP 1X, 0,   1,  1,       9, 80, 105
	gfxmap_end label word

	GMODES	LABEL	WORD
		PRNMODE	0, 80, 72
		PRNMODE	1,160, 72
	MAXMODE	EQU	1

	PMODE_PRT0 DW	8
		DB	27,'N',27,'S'
	PMODE_LEN0 LABEL BYTE
		DB	gr_dec_digits dup (0)	; Count goes here

	PMODE_PRT1 DW	8
		DB	27,'P',27,'S'
	PMODE_LEN1 LABEL BYTE
		DB	gr_dec_digits dup (0)	; Count goes here

	GSETUP	LABEL	WORD
		DW	7		; Initialize printer to gfx spacing
		DB	15		; Shift In (cancel double width)
		DB	27,'T16',27,'>' ; 16/144" (8 pixel lines), unidirectional printing

	NSPACE	DW	6
		DB	27,'A'		; Reset printer to 1/6" spacing
		DB	27,'<'		; Bidirectional printing
		DB	27,'N'		; 10 Pitch

	EGADSTR GR_OFF,<>		; Inter-ribbon code (n/a since B&W only)
	EGADSTR CR,<13>			; CR only
	MLCRLF LABEL WORD		; Same as CRLF:
	EGADSTR CRLF,<13,10>		; CR/LF pair

;	NEC uses LSB on top

	PATTERN	200, 4, 8
		db	00000011b
		db	00001100b
		db	00110000b
		db	11000000b
	PATTERN	6, 6, 8
		db	00000001b
		db	00000110b
		db	00001000b
		db	00010000b
		db	01100000b
		db	10000000b
	PATTERN 7, 7, 8
		db	00000011b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	10000000b
	PATTERN 350, 8, 8
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	10000000b
	PATTERN 9, 9, 8
		db	00000001b
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	10000000b
		db	0		; end of patterns

	;	Text mode, Attribute definitions.

	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_emph	; 1
		DW	text_under	; 2
		DW	text_cond	; 3

	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1 ; normally 3

	EGADSTR TEXT_NOR,  <27,'N',27,'"',27,'Y'> ; 10cpi,bold off,underline off
	EGADSTR TEXT_EMPH, <27,'!'>		; emphasized (bold)
	EGADSTR TEXT_UNDER,<27,'X'>		; underline
	EGADSTR TEXT_COND, <27,'Q'>		; 17cpi

	EGADSTR EXT_CHARS,<27,'&'>	; Enable extended character set
	;
	;	Translation table for characters > 128
	;
	ASCII_XLAT LABEL BYTE
		; 8_H: Foreign letters:
		DB	'CueaaaaceeeiiiAA'
		; 9_H:
		DB	'EAAooouuyOUcLYPf'
		; A_H:
		DB	'aiounNao?',98h,99h,0cdh,0ceh,'!<>'
		; B_H:
		DB	87h,87h,87h,96h,92h,92h,92h,99h,99h,092h,096h,99h,9bh,9bh,9bh,99h
		; C_H:
		DB	9ah,90h,91h,93h,95h,8fh,93h,93h,9ah,98h,90h,91h,93h,95h,8fh,90h
		; D_H:
		DB	90h,91h,91h,9ah,9ah,98h,98h,8fh,8fh,9bh,98h,87h,84h,8bh,8bh,84h
		; E_H: Greek letters &c:
		DB	0a0h,0a1h,0b9h,0afh,0bah,0b1h,0abh,0b2h,0a2h,0b4h,0a7h,0bch,0cbh,0b4h,0a4h,0bch
		; F_H: Math Symbols:
		DB	'=',0c4h,0c6h,0c7h,09ch,09fh,'/',0c8h,0cfh,0ddh,0ddh,0beh,'n',0d1h,0ech

	;	Up to 1280 Bytes across the page, plus two bytes of length
	BUFLEN	EQU	1282

	; 8 dither levels
	DITHER_LEVELS	EQU 8			; # of dither patterns
	DITHER_WIDTH	EQU 8			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither table

	DITHER_TABLE LABEL WORD
		DB	   0,   0,   0,   0,   0,   0,   0,   0	; 0-Level Dither
		DB	080H,008H,020H,002H,080H,008H,020H,002H	; 1
		DB	011H,0A0H,044H,00AH,011H,0A0H,044H,00AH	; 2
		DB	084H,021H,048H,012H,084H,021H,048H,012H	; 3
		DB	044H,0AAH,011H,0AAH,044H,0AAH,011H,0AAH	; 4
		DB	099H,0AAH,066H,055H,099H,0AAH,066H,055H	; 5
		DB	055H,0AAH,055H,0AAH,055H,0AAH,055H,0AAH	; 6
		DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH	; 7

	; End of NEC code

