; ********************************************
; DRIVERS FOR:
;
; Okidata 82/83/92/93
; Okidata 292 (Non IBM compatible model)
; ********************************************
; 

IF (prn_mfg eq mfg_oki) and (prn_mdl lt mdl_oki292)
	; Okidata 82/83/92/93

	PRN_GR		= GR_QUO
	GR_QUOTE	= 3		; Command character to quote
	prn_chrset	= chrset_ascii7	; Standard PC-8 to ASCII translation
	prn_byte	= byte_vert

	; Unfortunately, the pixels on this printer are so large
	; (only 60x72 dpi) that we have to pack several screen
	; pixels into one printer pixel.

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   1,  0,     200, 80, 105
	GFXMAP 1,  0,   2,  1,     200, 80, 105
	GFXMAP 2,  0,   1,  1,     200, 80, 105
	GFXMAP 3,  0,   1,  1,     480, 80, 107
	GFXMAP 4,  0,   1,  1,     480, 80, 107
	GFXMAP X,  0,   1,  1,     480, 80, 107
	; No Alternate modes available
	gfxmap_end label word

	GMODES	LABEL	WORD
		PRNMODE	0, 60, 72
	MAXMODE	EQU	0

	PMODE_PRT0	DW	0	; resolution set when gfx mode entered
	PMODE_LEN0	DW	?	; (Length put here, but ignored)

	EGADSTR	GSETUP,<13,10,28,3>	; CR/LF, 12 cpi (if available), gfx mode

	GR_OFF	DW	0		; Graphics remain on during printing

	MLCRLF	DW	2
		DB	3,14		; 7 dot vertical advance

	NSPACE	DW	4		; Reset after graphics complete
		DB	3,2,13		; Exit graphics mode; do CR
		DB	30		; 10 cpi

	CR	DW	1
		DB	13		; CR, no line feed

	CRLF	DW	2
		DB	13,10

	; Patterns: Based on 7 printer pixels per pass; LSB on top
	; Assumes 60x72 dpi graphics mode.

	PATTERN	200, 7, 7
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
	PATTERN	480, 6, 7
		db	00000001b
		db	00000110b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	0		; end of patterns

	;	576 Bytes across the page, plus two bytes of length
	BUFLEN	EQU	642

	DITHER_LEVELS	EQU 2			; # of dither patterns (ON/OFF only)
	DITHER_WIDTH	EQU 2			; 2 bytes/level
	NDITHERS	EQU 1			; 1 dither table

	DITHER_TABLE LABEL WORD
		DB	0,0
		DB	0FFH,0FFH
	
	color_xlat label byte
		db	0,1,1,1,1,1,1,1

	; End of Okidata
ENDIF 

IF ((prn_mfg eq mfg_Oki) and (prn_mdl eq MDL_OKI292))
	;	Okidata 292 (Non IBM compatible model) has
	;	strange codes:
	;	- basically like Oki 92
	;	- allows 8-pin graphics (LSB on top like other Oki's)
	;	- Epson color select codes

	PRN_GR	EQU	GR_QUO
	GR_QUOTE EQU	3		; Command character to quote
	prn_chrset	= chrset_ascii7	; Standard PC-8 to ASCII translation
	prn_byte	= byte_vert

	;	Graphics Mode definitions.
	;

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   3,  0,     200, 80, 105	; 320x200, 8x5.6"
	GFXMAP 1,  0,   1,  0,       6, 80, 105	; 640x200
	GFXMAP 2,  0,   2,  1,       9, 80, 105	; 640x350, 5.8x7.9" (rot.)
	GFXMAP 3,  1,   3,  0,       9, 80, 105	; 640x480, 8x5.9"
	GFXMAP 4,  0,   2,  1,      10, 80, 105 ; 720x348, 5.8x8" (rot.)
	GFXMAP X,  1,   2,  0,      13, 80, 105	; Reduction
	; Alternate Epson modes:
	GFXMAP 10, 0,   2,  1,       8, 80, 105	; 320x200, 3.33x4.44" (rot.)
	GFXMAP 11, 0,   3,  1,      10, 80, 105	; 640x200, 5x7.1" (rot.)
	GFXMAP 12, 1,   2,  0,      10, 80, 105	; 640x350, 5.3x3.9"
	GFXMAP 13, 1,   3,  1,       9, 80, 105	; 640x480, 6x7.9" (rot.)
	GFXMAP 14, 1,   2,  0,       9, 80, 105 ; 720x348, 6x4.3"
	GFXMAP 1X, 1,   2,  1,      13, 80, 105	; Reduction
	gfxmap_end label word

	GMODES	LABEL	WORD
		PRNMODE	0, 120, 72
		PRNMODE	1, 240, 72
	MAXMODE	EQU	1

	PMODE_PRT0	LABEL WORD
	EGADSTR PMODE_PRT1,<3>		; enter graphics mode

	PMODE_LEN0	LABEL WORD
	PMODE_LEN1	DW	?	; (Length put here, but ignored)

	GSET_PER_MODE	EQU	TRUE	; Setup strings for each graphic mode

	GSETUP	DW	GSET120, GSET240
	; Set printer to 120 dpi ("double density"):
	; 10 cpi, 16/144" line spacing, dbl density gfx
	EGADSTR	GSET120,<13,10,30,27,'%9',16,27,'R'>
	; 240 dpi: 10 cpi, 16/144" spacing, quad density
	EGADSTR	GSET240,<13,10,30,27,'%9',16,27,'#Q'>

	EGADSTR GR_OFF,<3,2,13>		; exit graphics mode; do CR

	NSPACE	DW	6		; Reset after graphics complete
		DB	3,2,13		; Exit graphics mode; do CR
		DB	30		; 10 cpi
		DB	27,'6'		; 6 lines/inch

	EGADSTR CR,<13>			; CR, no line feed
	MLCRLF LABEL WORD		; Same as CRLF:
	EGADSTR CRLF,<13,10>		; CR + LF

	NBUFFERS EQU 4
	YELLOW LABEL WORD
	EGADSTR GR_YELLOW, <27,'r',4>	; Select yellow ribbon
	MAGENTA LABEL WORD
	EGADSTR GR_MAGENTA,<27,'r',1>	; Select magenta ribbon
	CYAN LABEL WORD
	EGADSTR GR_CYAN,   <27,'r',2>	; Select cyan ribbon
	BLACK LABEL WORD
	EGADSTR GR_BLACK,  <27,'r',0>	; Select black ribbon

	;	Up to 1920 Bytes across the page, plus two bytes of length
	BUFLEN	EQU	1922

	;	This printer, like other Microlines, has LSB on top;
	;	unlike other Microlines, it allows use of all 8 pins.

	PATTERN 200, 4, 8		; 4 Screen Lines per Print Row
		db	00000011b
		db	00001100b
		db	00110000b
		db	11000000b
	PATTERN 6, 6, 8
		db	00000001b
		db	00000010b
		db	00001100b
		db	00010000b
		db	00100000b
		db	11000000b
	PATTERN 8, 8, 8
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	10000000b
	PATTERN 9, 9, 8
		db	00000001b
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	10000000b
	PATTERN 10, 10, 8
		db	00000001b
		db	00000001b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00010000b
		db	00010000b
		db	00100000b
		db	01000000b
		db	10000000b
	PATTERN 13, 13, 8
		db	00000001b
		db	00000010b
		db	00000010b
		db	00000100b
		db	00001000b
		db	00001000b
		db	00010000b
		db	00010000b
		db	00100000b
		db	00100000b
		db	01000000b
		db	10000000b
		db	10000000b
		db	0		; end of patterns

	DITHER_LEVELS	EQU 4			; # of dither patterns
	DITHER_WIDTH	EQU 8			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither table

	; Entries in this table are taken from 8-level table in Epson section

	DITHER_TABLE LABEL WORD
	 DB	   0,   0,   0,   0,   0,   0,   0,   0	; 0-Level Dither
	 DB	0AAH,   0,   0,   0,0AAH,   0,   0,   0 ; 2-
	 DB	0FFH,   0,0AAH,055H,0FFH,   0,0AAH,055H ; 4-
	 DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH	; 7

	; Translate abstract colors	(--yymmcc)
	;    to physical ones		(kkccmmyy)
	COLOR_XLAT LABEL BYTE
		db	000h,010h,020h,030h,004h,014h,024h,034h
		db	008h,018h,028h,038h,00Ch,01Ch,02Ch,03Ch
		db	001h,011h,021h,031h,005h,040h,025h,035h
		db	009h,019h,029h,039h,00Dh,01Dh,02Dh,03Dh
		db	002h,012h,022h,032h,006h,016h,026h,036h
		db	00Ah,01Ah,080h,03Ah,00Eh,01Eh,02Eh,03Eh
		db	003h,013h,023h,033h,007h,017h,027h,037h
		db	00Bh,01Bh,02Bh,03Bh,00Fh,01Fh,02Fh,0C0h

	; End of Okidata Microline 292 code
ENDIF
