; ********************************************
; DRIVERS FOR:
;
; PostScript (Level I)
; COLOR PostScript (Level II)
; ********************************************
; 
	;	NOTE: Postscript colors (on color models) are handled
	;	by color number, not by plane.

 IF (prn_typ and typ_color)
	PRN_GR		EQU GR_DEC + GR_XHEX
 ELSE
	PRN_GR		EQU GR_DEC + GR_XHEX + GR_NOT
 ENDIF
	GR_DEC_DIGITS	= 3
	prn_byte	= byte_horiz
	prn_chrset	= chrset_adobe
	GSET_PER_MODE	EQU	TRUE	; Setup strings for each graphic mode
	POST_XLAT	EQU	TRUE	; Postscript translation
	NO_RESET_ATTRS	EQU	TRUE	; Don't reset attributes at end of text

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   1,  0,     200, 78, 105
	GFXMAP 1,  1,   1,  0,     200, 78, 105
	GFXMAP 2,  2,   1,  0,     200, 78, 105
	GFXMAP 3,  3,   1,  0,     200, 78, 105
	GFXMAP 4,  4,   1,  0,     200, 78, 105
	GFXMAP X,  9,   1,  0,     200, 78, 105

	GFXMAP 10, 5,   1,  1,     200, 78, 105
	GFXMAP 11, 6,   1,  1,     200, 78, 105
	GFXMAP 12, 7,   1,  1,     200, 78, 105
	GFXMAP 13, 3,   1,  1,     200, 78, 105
	GFXMAP 14, 8,   1,  1,     200, 78, 105
	GFXMAP 1X, 9,   1,  1,     200, 78, 105
	gfxmap_end label word

	;	Graphics Mode definitions.
	;

	GMODES	LABEL	WORD
		PRNMODE	0, 42, 35
		PRNMODE	1, 85, 35
		PRNMODE	2, 85, 62
		PRNMODE	3, 85, 85
		PRNMODE	4, 96, 62
		PRNMODE	5, 35, 42
		PRNMODE	6, 35, 85
		PRNMODE	7, 62, 85
		PRNMODE	8, 62, 96
		PRNMODE	9,110,110
	MAXMODE	EQU	9

	GXSETUP	DW	GXSETX-$-2
 IF (prn_typ and typ_color)
		DB	'%!PS-Adobe-2.0',13,10
 ELSE
		DB	'%!PS-Adobe-1.0',13,10
 ENDIF
		DB	'%%Title: EGAD Screen Print',13,10
		DB	'%%Pages: 1',13,10
		DB	'%%BeginProcSet: TextProcs 1.0 0',13,10
		DB	'/edata { /qdata exch string def '
		DB	'currentfile qdata readhexstring pop } bind def',13,10
 IF (prn_typ and typ_color)
		DB	'/egad { dup /qlen exch def   % save # of bytes (also samples)',13,10
		DB	'qlen 1 2 [1 0 0 -1 0 1] qlen edata false 4 colorimage % display image',13,10
 ELSE
		DB	'/egad { dup /nbytes exch def   % save # of bytes',13,10
		DB	'dup add /qlen exch def % save # of samples',13,10
		DB	'qlen 1 4 [1 0 0 -1 0 1] nbytes edata image % display image',13,10
 ENDIF
		DB	'0 -1 translate % move down',13,10
		DB	'} bind def',13,10
		DB	'%%EndProcSet',13,10,'%%EndProlog',13,10
		DB	'%%Page: one 1',13,10
		DB	'27 770 translate',13,10
	GXSETX	LABEL	BYTE

	GSETUP	DW	G320200P, G640200P, G640350P, G640480, G720348P
		DW	G320200L, G640200L, G640350L, G640480, G720348L
		DW	G800600

	EGADSTR G320200P,<'1.7 2.04 scale ' ,13,10>
	EGADSTR G320200L,<'2.04 1.7 scale ' ,13,10>
	EGADSTR G640200P,<'0.85 2.04 scale ',13,10>
	EGADSTR G640200L,<'2.04 0.85 scale ',13,10>
	EGADSTR G640350P,<'0.85 1.17 scale ',13,10>
	EGADSTR G640350L,<'1.17 0.85 scale ',13,10>
	EGADSTR G640480 ,<'0.85 0.85 scale ',13,10>
	EGADSTR G720348P,<'0.75 1.17 scale ',13,10>
	EGADSTR G720348L,<'1.17 0.75 scale ',13,10>
	EGADSTR G800600 ,<'0.65 0.65 scale ',13,10>

	PMODE_PRT0 LABEL BYTE
	PMODE_PRT1 LABEL BYTE
	PMODE_PRT2 LABEL BYTE
	PMODE_PRT3 LABEL BYTE
	PMODE_PRT4 LABEL BYTE
	PMODE_PRT5 LABEL BYTE
	PMODE_PRT6 LABEL BYTE
	PMODE_PRT7 LABEL BYTE
	PMODE_PRT8 LABEL BYTE
	PMODE_PRT9 LABEL BYTE
		DW	PMODE_END-$-2	; Length of string
	PMODE_LEN0 LABEL BYTE
	PMODE_LEN1 LABEL BYTE
	PMODE_LEN2 LABEL BYTE
	PMODE_LEN3 LABEL BYTE
	PMODE_LEN4 LABEL BYTE
	PMODE_LEN5 LABEL BYTE
	PMODE_LEN6 LABEL BYTE
	PMODE_LEN7 LABEL BYTE
	PMODE_LEN8 LABEL BYTE
	PMODE_LEN9 LABEL BYTE
		DB	gr_dec_digits dup (0)	; Count goes here
		DB	' egad '	; followed by data
	PMODE_END LABEL BYTE

	; GR_OFF is sent after encoded data.
	EGADSTR GR_OFF,<13,10>

	EXT_CHARS LABEL BYTE
		DW	EXT_END-$-2
		DB	'%!PS-Adobe-2.0',13,10
		DB	'%%Title: EGAD Screen Print',13,10
		DB	'%%Pages: 1',13,10
		DB	'%%BeginProcSet: TextProcs 1.0 0',13,10
		DB	'/vpos 756 def',13,10
		db	'/choosefont { findfont 11 scalefont setfont } def',13,10
		db	'/newline { /vpos vpos 11 sub def 18 vpos moveto } def',13,10
		db	'/egadt { newline /egadstr 200 string def',13,10
		db	'{ currentfile egadstr readline {',13,10
		db	'(\f) search { show pop pop exit } { { (\033) search { show pop',13,10
		db	'dup dup length 1 sub 1 exch getinterval exch 0 get',13,10
		db	'dup 66 eq { /Courier-Bold choosefont } { dup 73 eq '
		db	'{ /Courier-Oblique choosefont',13,10
		db	'} { dup 88 eq { /Courier-BoldOblique choosefont }'
		db	' { /Courier choosefont } ifelse',13,10
		db	'} ifelse } ifelse pop } { show newline exit } ifelse',13,10
		db	'} loop } ifelse } { exit } ifelse } loop showpage } def',13,10
		DB	'%%EndProcSet',13,10,'%%EndProlog',13,10
		DB	'%%Page: one 1',13,10
		db	'/Courier choosefont egadt',13,10
	EXT_END	LABEL BYTE

	EGADSTR MLCRLF,<>
	EGADSTR FF,<0>			; Must contain 1 character.

	EGADSTR NSPACE,<"showpage",13,10,"%%Trailer",13,10> ; sent at end of graphics
	EGADSTR END_TEXT,<12,13,10>	  ; FF, CR, LF.

	EGADSTR	CR,<>			; CR only
	EGADSTR CRLF,<13,10>		; CR/LF pair

 IF (prn_typ and typ_color)
	PATTERN	200, 1, 1
		db	11111111b	; Just 1 pattern
		db	0

	dither_levels	equ  255	; 256 won't fit into byte!
	dither_width	equ    1
	ndithers	equ    1

	; Page print width = 8". Maximum dot density=100 dpi. 1 pixel/byte.
	; Maximum buffer size: 800, plus 2 bytes of length.
	BUFLEN	EQU	802

	DITHER_TABLE	LABEL WORD
	COLOR_XLAT	LABEL BYTE
		; PostScript colors are: ccmmyykk
		; "Abstract" colors    : --yymmcc
		; 0-63 analogues:
		db	000h,040h,080h,0C0h,010h,050h,090h,0D0h
		db	020h,060h,0A0h,0E0h,030h,070h,0B0h,0F0h
		db	004h,044h,084h,0C4h,014h,001h,094h,0D4h
		db	024h,064h,0A4h,0E4h,034h,074h,0B4h,0F4h
		db	008h,048h,088h,0C8h,018h,058h,098h,0D8h
		db	028h,068h,002h,0E8h,038h,078h,0B8h,0F8h
		db	00Ch,04Ch,08Ch,0CCh,01Ch,05Ch,09Ch,0DCh
		db	02Ch,06Ch,0ACh,0ECh,03Ch,07Ch,0BCh,003h
 ELSE
	;	Laser printer - bytes run HORIZONTALLY.  Raster graphic
	;	commands produce one horizontal line of dots.
	;	The MSB is on the left of each byte.
	;	The REPEAT field above repeats each scan line, allowing
	;	dithering into successive print rows.
	;	[2 bit patterns, 2 bits/output byte]
	PATTERN	200, 2, 2
		db	11110000b
		db	00001111b
		db	0		; end of patterns

	; Page print width = 8". Maximum dot density=100 dpi. 2 bits/byte.
	; Maximum buffer size: 400, plus 2 bytes of length.
	BUFLEN	EQU	402

	; 16 shades of gray
	DITHER_LEVELS	EQU 16
	DITHER_WIDTH	EQU 1
	NDITHERS	EQU 1			; 1 dither table

	; Screen colors get run through the translation table
	; to translate them to printer color #'s. That is AND'ed
	; with the PATTERN above to get either 0*h or *0h, then
	; the value in the "DITHER" below is AND'ed with that and
	; placed in the printer output buffer.  All of which is
	; to say that this is not really a DITHER but just an
	; IDENTITY to get actual colors in the output stream.
	; -- wl 06/08/93
	DITHER_TABLE	LABEL WORD
		db	000h,022h,044h,066h,088h,0aah,0cch,0ffh
		; standard colors (for LaserJet compatibility) are 0..7.
		; Additional gray tones are provided as 8..15.
		db	011h,033h,055h,077h,099h,0bbh,0ddh,0eeh
 ENDIF

	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_emph	; 1
		DW	text_undr	; 2
		DW	text_ital	; 3
	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1 ; normally 3

	EGADSTR	TEXT_NOR ,<27,'N'>	; normal
	EGADSTR TEXT_EMPH,<27,'B'>	; bold
	EGADSTR TEXT_UNDR,<27,'X'>	; underline
	EGADSTR TEXT_ITAL,<27,'I'>	; italic

