#
# MAKE FILE FOR:
#
#	EGAD Screen Print		Version 2.40
#	OEM VERSION
#
# Copyright (c) 1992 LS Software
#
#	*** NOTE ***
#
#	This makefile *DOES NOT* rebuild the various EGAD*.OBJ files.
#	Before executing this makefile, use the standard EGAD makefile
#	to ensure all standard object files are up-to-date.
#

DRIVER_COMMON=egaddrv.asm egaddata.asm global.inc macros.inc

LINK_OPTS=/NOI/E

#
# By substituting GETBOX_S.OBJ for GETBOX.OBJ, the action of the Crop box
# is disabled.  /B is thus useless.  Unless the /R switch is used, the whole
# screen will always be printed.  -- wl 12/11/92
#
# LINK_COMMON=egadoem.obj dodump.obj getbox_s.obj

# GETBOX_L will allow cropping, but has limited functionality.
# -- wl 12/22/92
LINK_COMMON=egadoem.obj dodump.obj getbox_l.obj dline.obj

ASM=MASM
# ASM=TASM /jQUIRKS /m2
ASM_OPTS=/MX

.asm.obj:
	$(ASM) $(ASM_OPTS) $*.asm,,NUL;
# Below line makes Listing files:
#	$(ASM) $(ASM_OPTS) $*.asm,,$*;

.obj.exe:
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		Common to all drivers:
#

# GETBOX_S is the "stub" version of GETBOX -- it does nothing.

getbox_s.obj:	$*.asm global.inc

# GETBOX_L allows cropping, but has limited functionality.

getbox_l.obj:	getbox.asm global.inc
	$(ASM) $(ASM_OPTS) /DLIMITED getbox.asm,getbox_l.obj,NUL;

egadoem.obj:	egad.asm global.inc version.inc 
	$(ASM) $(ASM_OPTS) /DOEM egad.asm,egadoem.obj,egadoem.lst;

#
#		EGADEP - Epson & Compatible printers
#

xgadep.exe:	egadep.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADLQ - 24-pin Epson LQ/Compatible

xgadlq.exe:	egadlq.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADLQ - 24-pin Epson LQ/Compatible Color

xgadlqc.exe:	egadlqc.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADMX - Epson MX-80 with GrafTrax (120 dpi only)
#

xgadmx.exe:	egadmx.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADEPC - Epson & Compatible Color Printers
#

xgadepc.exe:	egadepc.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADPP - IBM ProPrinter & Compatibles
#			NOTE: For 24-pin printers, with 1/60" instead of
#			1/72" vertical dots.
#

xgadpp.exe:	egadpp.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADPPC - IBM ProPrinter & Compatible COLOR matrix
#			NOTE: For 24-pin printers, with 1/60" instead of
#			1/72" vertical dots.
#

xgadppc.exe:	egadppc.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADHP - For HP LaserJet
#

xgadhp.exe:	egadhp.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;


#		EGADHP2 - LaserJet Series II or above

xgadhp2.exe:	egadhp2.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#		EGADHP3 - LaserJet IID, IIP, Series III
#			  (with data compression mode)

xgadhp3.exe:	egadhp3.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADPJ - For HP Paintjet
#

xgadpj.exe:	egadpj.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADQJ - For HP QuietJet
#

xgadqj.exe:	egadqj.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADDJ - For HP DeskJet 500
#

xgaddj5.exe:	egaddj5.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADDJ5C - For HP DeskJet 500C
#

xgaddj5c.exe:	egaddj5c.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADDJ55 - For HP DeskJet 550C
#

xgaddj55.exe:	egaddj55.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADST - For Star Gemini, Delta, Radix,
#			 SG, SD, and SR printers
#

xgadst.exe:	egadst.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADNEC - For NEC-8023 and C. Itoh 8510 printers
#

xgadnec.exe:	egadnec.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADDP - For Dataproducts 8050 printers
#

xgaddp.exe:	egaddp.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADPT - For Paper Tiger printers
#

xgadpt.exe:	egadpt.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADOKI - For Okidata 82/83/92/93 printers
#

xgadoki.exe:	egadoki.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADO292 - Okidata Microline 292 (Non-IBM compatible model)
#

xgado292.exe:	egado292.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADMPI - For MPI printers
#

xgadmpi.exe:	egadmpi.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADIBJ - IBM Colorjet 3852-2
#

xgadibj.exe:	egadibj.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADDMP - For Radio Shack DMP-105 printers
#

xgaddmp.exe:	egaddmp.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADCGP - For Radio Shack CGP-220 printers
#

xgadcgp.exe:	egadcgp.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADTOSH - For Toshiba P1340, P1350, P3x1 printers
#

xgadtosh.exe:	egadtosh.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADCAN - For Canon LBP printers
#

xgadcan.exe:	egadcan.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		EGADPOST - PostScript
#

xgadpost.exe:	egadpost.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

xgadpsc.exe:	egadpsc.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

xgadxe.exe:	egadxe.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

xgadpcpi.exe:	egadpcpi.obj $(LINK_COMMON) video_pc.obj
	link	$(LINK_OPTS) $**, $@,NUL,;

#
#		Update distribution directory:
#

always:
#	move	xgad*.exe \work\egad\oem\egad*.exe
#	xcopy	xgad*.exe \work\egad\oem\egad*.exe
	for %a in (xgad*.exe) do move %a ..\oem\E%@substr[%a,1]
