	PAGE	88,132
	TITLE	VIDEO_PC -- EGAD Screen Print (c) 1991 LS Software
	SUBTTL	PC Video Support
;
;	EGAD Screen Print
;
;	COPYRIGHT (C) 1988-1994, 1995 LS Software
;
	PUBLIC  READPT, PLOTPT, RESET
	PUBLIC	GETMODE, GET_MODE_PTR, BEEP
	PUBLIC	TEST_KBD, READ_KBD, KBD_SETUP, KBD_RESET

	PUBLIC	COPYRIGHT_MSG, DEFAULT_PRN
	PUBLIC	VIDEO_MODE, VIDEO_PAGE
	PUBLIC	DISP_ROWS, DISP_COLS, BYTES_ROW
	PUBLIC	FORCE_MODE

	PUBLIC	VMODE_TYPE

INCLUDE	GLOBAL.INC

	ASSUME	CS:_TEXT, DS:_DATA, SS:STACK, ES:_DATA

START_DATA	SEGMENT	WORD PUBLIC 'INIT'
COPYRIGHT_MSG LABEL BYTE
	DB	13,10
	DB	'EGAD -- VGA/EGA/CGA Screen Print  Copyright (c) 1995',13,10
	DB	'   LS Software',9,9,9,'Driver for: $'
START_DATA	ENDS

; -------------------- E Q U A T E S -----------------------

; Video Display Area Segments
CGA_SEG		equ	0B800H
MGA_SEG		equ	0B000H
EGA_SEG		EQU	0A000H

MDA_MODE	EQU	7		; Monochrome display mode

	SUBTTL	PC Video Support (Data Areas)
;
; ------------------ D A T A    A R E A --------------------
;
_DATA	SEGMENT

	ALIGN	2

JUMP_TABLE LABEL WORD
	DW	READ_CGA_TEXT,	  WRITE_CGA_TEXT	; 00
	DW	READ_CGA_TEXT,	  WRITE_CGA_TEXT	; 01
	DW	READ_CGA_TEXT,    WRITE_CGA_TEXT	; 02
	DW	READ_CGA_TEXT,	  WRITE_CGA_TEXT	; 03
	DW	READ_CGA_320,     WRITE_CGA_320		; 04
	DW	READ_CGA_320,     WRITE_CGA_320		; 05
	DW	READ_CGA_640,     WRITE_CGA_640		; 06
	DW	READ_MGA,         WRITE_MGA		; 07
	DW	READ_HGC,	  WRITE_HGC		; 08
	DW	READ_MODE_9,	  WRITE_MODE_9		; 09 (PCjr)
	DW	READ_VGA_SUPER,   WRITE_VGA_SUPER	; 0A (PCjr)
	DW	READ_NONE,	  WRITE_NONE		; 0B
	DW	READ_NONE,	  WRITE_NONE		; 0C
FIRST_EGA_MODE EQU (($-JUMP_TABLE)/4)			; following is 1st EGA:
	DW	READ_EGA,         WRITE_EGA		; 0D
	DW	READ_EGA,         WRITE_EGA		; 0E
	DW	READ_EGA,	  WRITE_EGA		; 0F
	DW	READ_EGA,	  WRITE_EGA		; 10
FIRST_VGA_MODE EQU (($-JUMP_TABLE)/4)			; following is 1st VGA:
	DW	READ_EGA,	  WRITE_EGA		; 11
	DW	READ_EGA,	  WRITE_EGA		; 12
	DW	READ_VGA_320,     WRITE_VGA_320		; 13
MAX_IBM_MODE EQU (($-JUMP_TABLE)/4)-1			; previous was last IBM
; Pseudo-modes
	DW	READ_VGA_SUPER,   WRITE_VGA_SUPER	; all Super VGA modes
PSEUDO_VGA_MODE EQU (($-JUMP_TABLE)/4)-1

; Ensure that the pseudo-VGA mode is the same as the maximum mode supported.
.ERRNZ MAX_MODE - PSEUDO_VGA_MODE

; NOTE: Mode 6 has 'monox' bit set because some software apparently sets the
; BIOS mode to 6 when in Hercules graphics.
;
; In the case of modes with vm_varsize set, the (X,Y) sizes indicate the
; MAXIMUM ALLOWABLE size for that mode, as computed from BIOS variables.
;
; "Palette Index" = 0 for 2-color, 1 for 4-color, 2 for 16-color gfx,
;		    3 for 16-color or monochrome text.
; NOTE: Max Color is the the max. index into the color palette,
; not the actual maximum color displayable.
VMODE_TYPE LABEL WORD
	;					 Max  Def.  Palette
	;		Modifiers	   X   Y Colr,Inc and Aspect
	video_size <vm_text		 , 40, 24, 15, 1,vm_pal_t>		; 0
	video_size <vm_text		 , 40, 24, 15, 1,vm_pal_t>		; 1
	video_size <vm_text		 , 80, 24, 15, 1,vm_pal_t>		; 2
	video_size <vm_text		 , 80, 24, 15, 1,vm_pal_t>		; 3
	video_size <0			 ,320,200,  3, 8,vm_pal_4+vm_asp_320>	; 4
	video_size <0			 ,320,200,  3, 8,vm_pal_4+vm_asp_320>	; 5
	video_size <vm_monox		 ,640,200,  1, 8,vm_pal_2+vm_asp_640c>	; 6
	video_size <vm_text+vm_mono	 , 80, 24,  1, 1,vm_pal_t>		; 7
	video_size <0			 ,720,348,  1, 8,vm_pal_2+vm_asp_herc>	; 8  (Herc gfx)
	video_size <0			 ,320,200, 15, 8,vm_pal_16+vm_asp_320>	; 9   PCjr
	video_size <0			 ,640,200,  3, 8,vm_pal_4+vm_asp_640c>	; 0a  PCjr
	video_size <0			 ,640,225,  7, 8,vm_pal_16+vm_asp_640c>	; 0b (Z-100)
	video_size <0			 ,640,480,  7,16,vm_pal_16+vm_asp_640v>	; 0c (Z-100 Hi-Res)
	video_size <vm_varsize+vm_egaregs,320,200, 15, 8,vm_pal_16+vm_asp_320>	; 0d (320x200x16)
	video_size <vm_varsize+vm_egaregs,640,200, 15, 8,vm_pal_16+vm_asp_640c>	; 0e (640x200x16)
	video_size <vm_varsize+vm_egaregs,800,600,  3,16,vm_pal_4+vm_asp_640e>	; 0f (640x350x4)
	video_size <vm_varsize+vm_egaregs,800,600, 15,16,vm_pal_16+vm_asp_640e>	; 10 (640x350x16)
	video_size <vm_varsize+vm_egaregs,800,600,  1,16,vm_pal_2+vm_asp_640v>	; 11 (640x480x2)
	video_size <vm_varsize+vm_egaregs,800,600, 15,16,vm_pal_16+vm_asp_640v>	; 12 (640x480x16)
	video_size <vm_varsize		 ,320,200,255, 8,vm_pal_16+vm_asp_320>	; 13 (320x200 256-color)
	video_size <vm_varsize		,1024,768,255,32,vm_pal_16+vm_asp_640v>	; 14 (Super VGA modes)
;
; Current Video Mode Characteristics:
;
disp_cols	dw	0		; Display columns
disp_rows	dw	0		; Display rows
bytes_row	dw	0		; Bytes per row
video_mode	db	?		; Video mode
video_page	db	?		; Video page
force_mode	db	FORCE_NORM	; Mode not forced
;
; Environment characteristics:
;
colr		DB	?
max_color	db	?	; Maximum color available (1, 3, 15, or 255)
default_prn	DW	0ffh	; Allow any default printer

maskbits	DB 080H,040H,020H,010H,008H,004H,002H,001H
mask2bits	DB 0C0H,030H,00CH,003H

_DATA	ENDS

	SUBTTL	GETMODE: Determine Video Mode Characteristics
	PAGE	+
_TEXT	SEGMENT

IF 1 ; IFDEF TEST_HERC
	EXTRN	PRINT_ONE_CHAR:PROC
ENDIF
;
;
; ------------------ C O D E    A R E A --------------------
;

;	GETMODE - Get the current video mode number.
;	Will work for "Super VGA" modes too, even though they are
;	not given consistent mode numbers by board manufacturers.
;
;	INPUT:	none
;	OUTPUT:	modifies variables:
;		disp_rows	Rows
;		disp_cols	Columns
;		video_page	Video Page #
;		video_mode	Video Mode # (or pseudo-mode #)
;		max_color	Set to maximum color on screen (1, 3, 15, 255)
;				[Only set for modes with vm_varsize set]
;	USES:	AX, BX, CX, DX
;
GETMODE	PROC	NEAR
	mov	ah,0Fh
	int	VID_INT		; AH = # Columns  AL = Mode #  BH = Page #
	mov	byte ptr bytes_row,ah	; # of Bytes/Row
	mov	byte ptr video_mode,al	; mode
	mov	byte ptr video_page,bh	; page

	push	es
	mov	bx,_BIOS
	mov	es,bx
	ASSUME	ES:_BIOS

	mov	al,ah			; # of Text columns...
	xor	ah,ah
	mov	disp_cols,ax		; ...into DISP_COLS
	mov	max_color,ah		; MAX_COLOR = 0 (unknown)

	call	get_mode_ptr		; CL=flags, CH=mode #, BX->vmode_type
	mov	al,es:screen_lines	; # of Text rows
	or	al,al			; If 0 (CGA/MDA), use 25 lines.
	jnz	gm_trows
	mov	al,24
gm_trows:
	inc	al
	mov	disp_rows,ax		; Actual # of text rows

	; Determine "ACTUAL" video mode here.

	cmp	ch,MAX_IBM_MODE		; Is it a Super VGA mode?
	mov	ch,force_mode		;   [FORCE flag in CH]
	ja	gm_super		; Super VGA: BX&CL invalid
	; Not a Super VGA mode.
	test	cl,vm_mono		; Monochrome adapter?
	jnz	gm_mono			; yes.
	; Probably not monochrome, although some software [RISA 2-D] sets the
	; BIOS mode to 6 while in Hercules graphics mode.
	test	cl,vm_monox		; Possible monochrome alias mode?
	jz	gm_modeok		; No, mode is OK.
	cmp	es:screen_port,03D0H	; Mono adapter port address?
	jae	gm_modeok		; No, mode is OK as is.

	; ** Fall through to Monochrome handler **
;
;	Monochrome adapter -- test for various MDA graphics modes
;
gm_mono:
	call	monochrome_status
	jmp	short gm_savemode
;
; Non-standard EGA/VGA mode processing
;
gm_super:
	cmp	ch,FORCE_TEXT		; If force_mode is 1, force
	je	gm_text			; a TEXT mode.
	cmp	ch,FORCE_GFX		; If force_mode is 2, force
	je	gm_pseudomode		; a GRAPHICS mode.
	; Attempt to determine whether Text or Graphics.
	mov	ax,es:screen_size	; Get number of displayed bytes (BIOS)
	or	ax,ax
	jz	gm_pseudomode		; Size=0, probably graphics
	cmp	ax,2000H		; If > 2000H, probably graphics too.
	ja	gm_pseudomode	
	; Probably SUPER EGA/VGA *TEXT* mode.
gm_text: mov	bl,3			; Use text mode number.
	jmp	short gm_savemode
gm_pseudomode:
	mov	bl,PSEUDO_VGA_MODE	; Non-standard mode: 'fake' gfx mode #
gm_savemode:
	mov	byte ptr video_mode,bl	; Save new video mode
gm_modeok:
	call	get_mode_ptr		; CX = mode flags byte
	mov	dl,vmode_type[bx].vmode_maxcolor
	mov	max_color,dl		; DL = max allowable color in this mode.
					; For Super VGA this will be 255.
	mov	ax,vmode_type[bx].vmode_cols ; Get # columns from table
	mov	bx,vmode_type[bx].vmode_rows ; Get # rows (kills BX)
	test	cl,vm_text		; Character mode?
	jnz	gm_exit			; If so, variables set above. Done.
	test	cl,vm_varsize		; Variable size?
	jz	gm_set			; No, take values from table.

	;	Determine maximum color available
	sub	bx,bx			; Coordinates are (0,0)
	mov	ax,bx
	call	readpt
	mov	dh,al			; Save color at (0,0) in DH

	mov	cl,dl			; Plot pixel with max allowable color
	mov	ax,bx			; Coordinates are (0,0)
	call	plotpt

	mov	ax,bx			; Coordinates are (0,0)
	call	readpt			; Read color back
	and	al,dl			; Limit to known maximum in DL
	; This section of code (wl 01/25/95) accounts for some video cards
	; (specif. Tony Hicks' of CSC) returning max_color = 0Dh in a 16 color
	; mode instead of the proper 0Fh. The only correct return values
	; are: 1, 3, 15, 255.
	test	al,0f0h			; At least one bit set in high nybble?
	jnz	gm_setmax		;  Must be 256 colors (DL=255)
	and	dl,00fh			; Restrict Maximum allowable to 15
	cmp	al,4			; If we read a color >= 4, assume 16
	jge	gm_setmax		;  color mode. (max allowable = 15)
	mov	dl,al			; Set max color = read_color (1 or 3)
					;  (Presumably we did not read 2!!)
gm_setmax:
	mov	max_color,dl		; DL saved as max_color.
	; end of modification (wl 01/27/95)
	mov	cl,dh			; DH = original value of pixel (0,0)
	mov	ax,bx			; Coordinates are (0,0)
	call	plotpt

IFDEF DEBUG
	call	showmaxcol
ENDIF

;	Standard EGA/VGA Graphics mode.  We get the size of the display
;	from the BIOS variables.  This should allow us to support most
;	'enhanced' video modes (such as EGA 640x480, etc.)
;	Determine size of screen
	call	get_size

gm_set:
	mov	disp_cols,ax		; Set Size variables
	mov	disp_rows,bx

gm_exit:
	pop	es

	RETN
GETMODE	ENDP

GET_SIZE PROC NEAR
;
;	GET_SIZE sets the variables DISP_COLS and DISP_ROWS
;	to the display size maintained by the BIOS.
;	OUTPUT: BX = # of Rows; AX = # of Columns
;
	call	get_mode_ptr		; BX -> video_size array
	mov	al,byte ptr disp_rows	; Get # of TEXT rows in AX
	cmp	al,60			; Disallow more than 60 rows
	jb	get_size_y
	mov	al,25			; Assume standard screen
get_size_y:
	mul	byte ptr es:font_height	; Multiply by scan lines/char to get
					; total scan lines displayed
	mov	dx,vmode_type[bx].vmode_rows ; Get maximum allowable # rows
	mov	cx,vmode_type[bx].vmode_cols ; Max. # columns
	mov	bx,ax			; Put ROWS in BX
	cmp	bx,dx			; Bigger than we can handle?
	jbe	get_size_x		; NO -- accept it.
	mov	bx,dx			; YES -- use maximum size.
get_size_x:
; Determine width of screen
	mov	ax,disp_cols		; Get # of TEXT columns in AX
;	mov	al,byte ptr disp_cols	; Get # of TEXT columns in AX
;	xor	ah,ah
	shl	ax,1			; Multiply by 8 for # of GRAPHICS COL'S
	shl	ax,1
	shl	ax,1
	; Look for 800x600 and 1024x768 modes.  -- wl 04/29/93
	cmp	ax,1000
	jge	get_size_1024		; > 1000 wide?
	cmp	ax,780
	jge	get_size_800
get_size_xok:
	cmp	ax,cx			; Allowable column width?
	jle	get_size_done
	mov	ax,cx			; Use max.
get_size_done:
	RETN

get_size_800:
	mov	ax,800			; assume 800x600
	mov	bx,600
	RETN

get_size_1024:
	mov	ax,1024			; assume 1024x768
	mov	bx,768
	RETN
GET_SIZE ENDP

MONOCHROME_STATUS PROC NEAR
;
; MONOCHROME_STATUS
; Entry:	CL = Video mode bits from vmode_type table 'modifiers'
;		CH = Force flag
; Returns:	BL = EGAD video mode
;
	mov	bl,MDA_MODE		; mode 7 or 8; nothing else will do!
	cmp	ch,FORCE_NORM		; User override?
	jnz	mono_force
	test	cl,vm_monox		; Some apps set mode = 6 to show mono
	jz	check_graphics		;  graphics mode. If not, attempt to 
					;  ascertain whether text or gfx mode.
	inc	bl			; Set to mode 8 (Herc graphics)
	retn

mono_force:
	dec	bl			; Go to force_mode_flag + MDA_MODE - 1
	add	bl,ch			; (i.e., 7 if flag=1, 8 if flag=2).
	retn
;
; Attempt to ascertain whether in Mono Text or Graphics mode.
;
check_graphics:
	mov	dx,es:screen_port	; Base screen port
	add	dl,6			; Vertical retrace port (03BAh)
	in	al,dx			; initial value
	mov	ah,al			;  (in AH)
	mov	cl,es:timer_tick	; Get system time tick
	add	cl,2			; time to wait for
cg_1:	in	al,dx			; Read screen status port
	and	ax,8080h		; Compare against original
	cmp	ah,al			; Did bit change?
	jne	test_herc		; YES! Must have Hercules card
	cmp	cl,es:timer_tick	; Has our wait elapsed?
	jne	cg_1			; NO -- keep waiting
	; Must not be Hercules card, as we saw no retrace status
	retn				; Save MDA mode
;
;	Test Hercules card to see if in graphics
;
test_herc:
	inc	dx			; DX = 03BBh (light pen port)
	out	dx,al			; RESET the light pen (AL=don't care)
	dec	dx			; CRT status
th0:	in	al,dx
	test	al,80h			; Wait for retrace to come...
	jnz	th0

th1:	in	al,dx
	test	al,80h			; and go...
	jz	th1

	cli
th2:	in	al,dx			; then come again...
	test	al,80h
	jnz	th2

	dec	dx			; LOAD light pen latch
	out	dx,al
	sti

	mov	dl,0B4h
	mov	al,10h
	out	dx,al
	inc	dx
	in	al,dx			; AL = Light Pen High

IFDEF TEST_HERC
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	 PUSH	AX
	  MOV	AL,'T'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'E'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'S'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'T'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'='
	  CALL	NEAR PTR PRINT_ONE_CHAR
	 POP	AX

	 PUSH	AX
	  SHR	AL,1			; OUTPUT HIGH NYBBLE
	  SHR	AL,1
	  SHR	AL,1
	  SHR	AL,1
	  ADD	AL,'0'
	  cmp	al,'9'
	  jle	thx
	  add	al,8			; MAKE 10 -> 'A'
thx:
	  CALL	NEAR PTR PRINT_ONE_CHAR
	 POP	AX

	 AND	AL,0FH			; OUTPUT LOW NYBBLE
	 ADD	AL,'0'
	 cmp	al,'9'
	 jle	thy
	 add	al,8			; MAKE 10 -> 'A'
thy:
	 CALL	NEAR PTR PRINT_ONE_CHAR

	 MOV	AL,13
	 CALL	NEAR PTR PRINT_ONE_CHAR
	 MOV	AL,10
	 CALL	NEAR PTR PRINT_ONE_CHAR
	POP	DX
	POP	CX
	POP	BX
	POP	AX
ENDIF
	cmp	al,0CH			; If <= 0Ch, it's Text mode.
	jbe	th3
	mov	bl,8
th3:	retn				; Save new video mode
MONOCHROME_STATUS ENDP

	SUBTTL	PC Environment Support Subroutines
	PAGE	+
	ASSUME	ES:_DATA
;
;  EXIT:
;	BX = pointer to VMODE_TYPE table entry for current video mode.
;	CH = current video mode
;	CL = VMODE_FLAGS byte
;
GET_MODE_PTR PROC NEAR
	mov	bl,byte ptr video_mode
	mov	ch,bl
	sub	bh,bh		; BX = video mode
	mov	cl,3
	shl	bx,cl		; BX = offset into table
	mov	cl,vmode_type[bx].vmode_flags
	retn
GET_MODE_PTR ENDP
; ----------------------------------------------------------------------------
;
;	Make a joyous noise!
;
BEEP	PROC	NEAR
	MOV	AX,0E07h
	INT	VID_INT
	RETN
BEEP	ENDP
;
;	Test keyboard status; Return 'Z'ero if no keys waiting.
;
TEST_KBD PROC	NEAR
	mov	ah,1		; Get keyboard status
	int	KEY_INT
	retn
TEST_KBD ENDP
;
;	Read keyboard character.
;	Return in AL.
;
READ_KBD PROC	NEAR
	xor	ah,ah		; Read keyboard char..
	int	KEY_INT
	RETN
READ_KBD ENDP
; ----------------------------------------------------------------------------
mult_dx_320 proc near	; uses ax - not saved
	shl	dx,1
mult_dx_160:
	shl	dx,1
mult_dx_80:
	shl	dx,1
mult_dx_40:	
	shl	dx,1	; * 2
	shl	dx,1	; * 4
	; Then multiply by ten
mult_dx_10:
	mov	ax,dx	; *  1
	shl	dx,1	; *  2
	shl	dx,1	; *  4
	add	dx,ax	; *  5
	shl	dx,1	; * 10
	ret
mult_dx_320 endp
; ----------------------------------------------------------------------------
	SUBTTL	PC Video Support (WRITE Pixel)
	PAGE	+
;	Plot a point on the screen.
;
;	Inputs: AX = X coordinate
;		BX = Y coordinate
;		CX = color to plot
;
PLOTPT PROC     NEAR
	push	es
	push	di
	push	si
	push	dx
	push	cx
	push	bx
; Get color
	mov	colr,cl
	mov	cx,ax		; Row in CX
	mov	dx,bx		; Column in DX
	mov	ax,2		; (WRITE is second pointer)
	jmp	plot_read_both	; Jump to code in common with READPT

WRITE_CGA_320:
WRITE_CGA_640:
	call	get_addr_cga
WRITE_CGAS:
	; Byte is at ES:BX.
	; CL = number of bits to shift
	; CH = color mask
	; AH = bit mask
	mov	al,es:[bx]	; Get the byte
	not	ah		; Change read mask to write mask
	and	al,ah		; Zero out this pixel
	mov	ah,colr		; Get the new color
	and	ah,ch		; Mask to maximum color
	shl	ah,cl		; Shift into position
	or	al,ah		; Combine into byte
	mov	es:[bx],al	; Put the byte
WRITE_NONE:
	RETN
; ---------------------------------------------------------------------
; write pixel for mode 9
; input: colr = color to write
;          cx = pixel column
;          dx = pixel row
WRITE_MODE_9:
	call	get_addr_mode9
	jmp	short write_cgas
; ---------------------------------------------------------------------
GRAPHICS_CTL    EQU     3CEH		;Address of Graphics controller

;************************************************************************
; Set pixel at X,Y to color given					*
; X in CX, Y in DX.							*
; using the PACKED PIXEL WRITE method					*
;************************************************************************

WRITE_VGA_SUPER:
	mov	ah,0CH		; Write dot
	mov	al,colr
	mov	bh,byte ptr VIDEO_PAGE
	int	VID_INT		; Use BIOS function
	RETN

WRITE_VGA_320:
	call	Get_Addr_VGA_320
	mov	al,colr
	mov	es:[bx],al
	RETN

WRITE_EGA:			; Most EGA & VGA modes
	; Convert x,y address into OFFSET:SEGMENT and get MASK
	CALL    Get_Addr_EGA	;Compute SEGMENT:OFFSET address
				;in ES:BX, Mask in CL
	MOV     DX,GRAPHICS_CTL	; Output port

	; Select write mode to be 'PACKED PIXEL WRITE'
	mov	ax,0205h	; 05 = MODE reg, 02 = PACKED WRITE
	out	dx,ax

	; Set mask register to preserve unused 7 bits in a byte
	mov	al,08h		; BIT MASK reg.
	mov	ah,cl		; Set reg to mask from Get_Addr_EGA
	out	dx,ax

	; Set the pixel to new color
	MOV     AL,colr		;Fetch color
	MOV     AH,ES:[BX]	;Must read to preserve old bits
	MOV     ES:[BX],AL	;Set pixel color to new value

	; Restore MODE and MASK registers
	mov	ax,0005h	; 5 = MODE reg, 0 = default write mode
	out	dx,ax

	mov	ax,0FF08h	; 8 = BIT MASK reg, 0FFh = All 8 bits (default)
	out	dx,ax

	RETN

; Write to Hercules Graphics.  CX = x coord; DX = y coord

WRITE_HGC:
	call	get_addr_hgc
	mov	al,colr
	cmp	al,0
	je	write_hgc_go
	mov	al,0FFH
write_hgc_go:	
	and	al,cl		; AL = 0 (writing 0) or proper bit
	mov	ah,es:[bx]	; Get byte
	not	cl		; Mask out bit
	and	ah,cl		; turn bit off
	or	ah,al		; 'OR' in new value
	mov	es:[bx],ah
	RETN

WRITE_CGA_TEXT:
READ_CGA_TEXT:
        mov     AX,CGA_SEG	; CGA text origin
	jmp	short w_text_ok
WRITE_MGA:
READ_MGA:
	mov	AX,MGA_SEG	; MGA text origin
w_text_ok:
	mov	bx,_BIOS	; ES = BIOS segment
	mov	es,bx
	ASSUME	ES:_BIOS
	mov	bx,ES:page_offset ; Offset of current page

	mov     ES,AX		; ES = Video segment
	ASSUME	ES:_DATA

	mov	al,dl		; Row (0 to 24)
	mov	ah,byte ptr disp_cols
	mul	ah		; AL*AH = Offset to screen row in AX
	add	ax,ax		; 2 bytes/character cell
	add	ax,cx		; Add column*2
	add	ax,cx		;   for offset to byte in memory
	add	bx,ax
	inc	bx
	xor	byte ptr es:[bx],077h
	RETN

PLOTPT	ENDP
	SUBTTL	PC Video Support (READ Pixel)
	PAGE	+
;
;	READPT -- Read a pixel from the screen
;
;	Inputs:  AX = X coordinate
;		 BX = Y coordinate
;	Returns: AL is pixel color
;		 AH is zero for modes below EGA.
;		    For EGA and above, AH contains maximum color
;		    (1, 3, 15, or 255).
;
READPT PROC	NEAR
	push	es
	push	di
	push	si
	push	dx
	push	cx
	push	bx

	mov	cx,ax		; Row now in CX
	mov	dx,bx		; Column in DX
	sub	ax,ax		; READ is first pointer

; PLOTPT also jumps here, as the following code is common to both.
PLOT_READ_BOTH:
	mov	BL,video_mode
	sub	bh,bh
	shl	bx,1		; Multiply by 4 for offset into table
	shl	bx,1		; 
	add	bx,ax		; For 1st or 2d pointer in table
	call	jump_table[bx]

	pop	bx
	pop	cx
	pop	dx
	pop	si
	pop	di
	pop	es
	retn

; ---------------------------------------------------------------------
; READ PIXEL ROUTINES:
; input:   cx = pixel column
;          dx = pixel row
; output:  ax = pixel value

; Do CGA read
READ_CGA_320:
READ_CGA_640:
	call	get_addr_cga
READ_CGAS:
	mov	al,es:[bx]	; Get the byte
	and	al,ah		; Keep only one pixel
	shr	al,cl		; Adjust to low nibble
	mov	ah,max_color	; Return maximum color
	; xor	ah,ah
READ_NONE:
	RETN

READ_MODE_9:
	call	get_addr_mode9
	jmp	read_cgas

; Read from Hercules Graphics.  CX = x coord; DX = y coord

READ_HGC:
	call	get_addr_hgc
	mov	al,es:[bx]	; Read the byte
	and	al,cl		; AND with the bit
	mov	al,0
	jz	read_hgc_go
	mov	al,1
read_hgc_go:
	mov	ah,max_color	; Return maximum color
	; xor	ah,ah
	RETN

;************************************************************************
; Common definitions for the next five routines				*
;************************************************************************

GRAPHICS_CTL    EQU     3CEH		;Address of Graphics controller
SEQUENCE_CTL    EQU     3C4H		;Address the Sequencer

;************************************************************************
; Read value of the pixel at x,y and return value in AX		 *
;************************************************************************

READ_VGA_SUPER:			; Use BIOS
	mov	ah,0DH		; Read pixel
	mov	bh,byte ptr VIDEO_PAGE
	int	VID_INT		; Call BIOS
	mov	ah,max_color	; Return maximum color
	RETN

READ_VGA_320:			; 320x200x256 color special code
	call	Get_Addr_VGA_320
	mov	al,es:[bx]
	mov	ah,255		; Show 256 color mode
	RETN

READ_EGA:			; Most VGA and EGA modes

	; Convert x,y address into OFFSET:SEGMENT and get MASK
	CALL    Get_Addr_EGA		;Compute SEGMENT:OFFSET address
					;in ES:BX, Mask in CL

	; Set MAP MASK register to read next plane and read next plane

	MOV     DX,GRAPHICS_CTL
	MOV     AL,04H			;Select MAP MASK register
	OUT     DX,AL
	INC     DX

	MOV     SI,BX			;Copy offset into register SI
	XOR     BH,BH			;Clear color
	MOV     BL,CL			;Copy mask into register CL
	MOV     CX,4			;Initialize loop counter
Read_Plane_Loop:
	SHL     BH,1
	MOV     AL,CL			;Select next plane for read
	DEC     AL
	OUT     DX,AL

	MOV     AH,ES:[SI]		;Fetch values for 8 pixels in plane 0
	AND     AH,BL			;Mask of the bit for our pixel (mask in
	JZ      Zero_Value		;Put 0 into next color bit
	OR      BH,1			;Put 1 into next color bit
Zero_Value:
	LOOP    Read_Plane_Loop

	MOV     AL,BH			;Put result into AX
	mov	ah,max_color	; Return maximum color
	; xor	ah,ah
	RETN

READPT ENDP

	SUBTTL	PC Video Support (RESET hardware)
	PAGE	+
;
;	RESET - Reset the EGA/VGA hardware
;
RESET PROC

	; Determine whether this mode uses EGA registers
	call	get_mode_ptr
	test	cl,vm_egaregs
	jz	not_ega		; Mode does not use EGA registers
	; reset the ega registers
	mov	dx,03ceh
	sub	ax,ax		; Zero
	out	dx,ax		; 00 -> set/reset reg
	inc	ax
	out	dx,ax		; 00 -> enable s/r reg
	inc	ax
	out	dx,ax		; 00 -> color compare
	mov	al,5
	out	dx,ax		; 00 -> mode reg
	mov	ax,00f07h
	out	dx,ax		; 0F -> color don't care reg
	mov	ax,0ff08h
	out	dx,ax		; FF -> bit mask reg
not_ega:
	retn

RESET	ENDP
	SUBTTL	PC Video Support (Routines -- Find Address of Pixel)
	PAGE	+
;************************************************************************
; Compute SEGMENT:OFFSET pair from a given x,y address			*
; of a pixel.  We know that there is BYTES_ROW bytes in each		*
; raster and that each byte contains eight pixels.			*
; To find offest of pixel x,y we use the following formula		*
;									*
;       OFFSET = BYTES_ROW * y + x/8					*
;									*
; To compute which bit within byte is to be changed we get		*
; (x mod 8) which is remainder when x is divided by 8.			*
; Which is same as keeping last three bits of x.  We use		*
; position within a byte to rotate value 80H so that the		*
; single bit matches the position in a byte.				*
; Recall that bit7 in a byte represents left most pixel.		*
; Thus MASK is computed as follows:					*
;									*
;       MASK = ROTATE 80H TO THE RIGHT BY (X AND 7)			*
;									*
; Entry: CX - X coordinate (pixel)					*
;	 DX - Y coordinate (raster)					*
; Exit:	 CL - Mask (x mod 8)						*
;	 ES:BX - Absolute address in display buffer			*
;************************************************************************

; NOTE: For Get_Addr_CGA,
; output: ah    bit mask
;         cl    number of bits to shift
;	  ch	bit mask for max. color
Get_Addr_CGA proc near
	mov	ax,_BIOS
	mov	es,AX
	ASSUME	ES:_BIOS
	mov	bx,page_offset

	mov	ax,CGA_SEG
	mov	es,ax
	ASSUME	ES:_DATA

	shr	dx,1		; Drop bottom bit -- even/odd scan lines
				; are in different buffers.
	jnc	ga_cga_even	; No carry indicates Y was even
	add	bx,2000h	; For odd row
ga_cga_even:
	call	mult_dx_80
	add	bx,dx		; Offset to scan line now in BX
	mov	dx,cx
	shr	dx,1		; Add X coordinate / 4
	shr	dx,1		; Yields offset to byte on line in DX
	cmp	video_mode,6
	jnz	ga_cga_low

	; For 640 wide graphics mode
	shr	dx,1		; Offset/2 since 8 pixels/byte
	add	bx,dx		; Get final offset (scanline+horiz) in BX
	push	bx
	 mov	bx,offset maskbits
	 mov	al,cl
	 and	al,7
	 xlat			; mov al,ds:[bx+al]
	 mov	ah,al		; Put bitmask in AH
	pop	bx
	not	cl		; Same as CL = 7 - CL    (think about it!)
	and	cl,7		; # of bits to shift (0..7) in CL
	mov	ch,1		; maximum color (mask)
	RETN

	; use mask2bits[]
ga_cga_low:
	add	bx,dx		; Get final offset (scanline+horiz) in BX
	push	bx
	 mov	bx,offset mask2bits
	 mov	al,cl
	 and	al,3
	 xlat
	 mov	ah,al		; Put bitmask in AH
	pop	bx
	not	cl		; Same as CL = 3 - CL    (think about it!)
	and	cl,3		; X Modulo 4 into CL
	shl	cl,1		; # of bits to shift (0..7) in CL
	mov	ch,3		; maximum color (mask)
	RETN
Get_Addr_CGA endp

Get_Addr_EGA     PROC    NEAR

	; Compute SEGMENT:OFFSET pair from x,y pair
	MOV     BX,BYTES_ROW		;Fetch bytes per raster
	cmp	bl,40
	je	get_addr_40
	cmp	bl,40
	jne	get_addr_other
get_addr_80:
	shl	dx,1
get_addr_40:
	call	mult_dx_40

get_addr_got_row:
	; At this point, the Offset to the byte is in DX.
	ASSUME ES:_BIOS
	push	es
	 mov	ax,_BIOS
	 mov	es,ax
	 add	dx,page_offset		; Add page start to byte offset
	pop	es
	ASSUME ES:_DATA

	; Compute MASK within byte from x coordinate in CX
	mov	al,cl			;Use bit number within X coordinate
	and     al,07H			; (0..7) as index into 'maskbits' array
	mov	bx,offset maskbits
	xlat				; Resulting mask in AL
	MOV     BX,CX			; Save X coordinate in BX
	mov     cl,al			;Keep mask in CL

	; Find byte offset within the scan line
	SHR     BX,1			; Offset is x mod 8
	SHR     BX,1
	SHR     BX,1
	ADD     BX,DX			;Add to scanline offset, result=BX
	MOV     AX,EGA_SEG		;Fetch segment and copy it into ES
	MOV     ES,AX
	RET

get_addr_other:
	mov	ax,dx			; Put Y in AX
	MUL     BX			; Multiply Y by bytes/row (into DX:AX)
	mov	dx,ax			; Put Offset into DX
	jmp	get_addr_got_row

Get_Addr_EGA     ENDP

; --------------------------------------------------------------------
Get_Addr_VGA_320 PROC NEAR
	call	mult_dx_320
	add	dx,cx		; DX = offset of selected byte
	mov	bx,dx		; into BX

        MOV     AX,EGA_SEG	;Fetch segment and copy it into ES
        MOV     ES,AX

	MOV	CL,0FFH		; Mask is all 8 bits
	RET
Get_Addr_VGA_320 ENDP

; --------------------------------------------------------------------
get_addr_mode9 proc near
; input:  cx    x-coorninate
;         dx    y-coordinate
; output: ah    bit mask
;         es:bx address of byte containing pixel
;         cl    number of bits to shift
	push	cx
	mov	ax,CGA_SEG	; Video base address for mode 9
	mov	es,ax
	mov	ah,dl
; Get offset of 50 line bank from screen base address
	and	ah,3		; Get modulo 4 of row
	ror	ah,1		; Generate bank offset
	ror	ah,1		; 1 => 2000, 2 => 4000, 3 => 6000
	ror	ah,1
	mov	bh,ah
	xor	bl,bl		; bank offset in bx
; Compute offset within bank of 50 lines
	shr	dx,1		; row / 4 = row in bank
	shr	dx,1
; Byte offset of row in bank = 160 * row in bank 
	call	mult_dx_160
	add	bx,dx		; Add offset to screen row
; Find offset into this screen line 
	pop	cx		; Get column number
	mov	ax,cx
	shr	ax,1		; 2 columns per byte
	add	bx,ax		; Offset to byte in screen memory
	and	cx,1		; Even pixel in high, odd in low nibble
	jnz	m9_a
	mov	ah,0f0h		; bit mask for even pixel
	mov	cl,4
	jmp	short m9_b
m9_a:	mov	ah,0fh		; bit mask for odd pixel
	xor	cl,cl
m9_b:	ret
get_addr_mode9 endp

; --------------------------------------------------------------------
Get_Addr_HGC PROC NEAR
	mov	bx,dx		; Copy of Y
	; Determine base address of 'bank' of interleaved scan lines
	and	dl,3		; ********|000000yy
	mov	dh,dl		; 000000yy|000000yy
	sub	dl,dl		; 000000yy|00000000
	ror	dh,1		; y000000y|00000000
	ror	dh,1		; yy000000|00000000
	ror	dh,1		; 0yy00000|00000000 (2000H=scan line 1)

	shr	bx,1		; Remove bottom 2 bits (bank #)
	shr	bx,1

	; Now multiply Y (in BX) by 90
	mov	ax,bx		; AX = Y
	shl	bx,1		; Y * 2
	shl	bx,1		; Y * 4
	add	bx,ax		; Y * 5 (Y*4+Y)
	shl	bx,1		; Y * 10
	mov	ax,bx		; AX = Y * 10
	shl	bx,1		; Y * 20
	shl	bx,1		; Y * 40
	shl	bx,1		; Y * 80
	add	bx,ax		; Y * 90 in BX
	add	bx,dx		; + Bank offset [BX is now offset of byte]

	MOV     DX,CX		; copy of X coord
	SHR     DX,1		;Get offset within raster as x mod 8
	SHR     DX,1
	SHR     DX,1
	ADD     BX,DX		;Add offsets together and keep in DX

	; Compute MASK within byte from x coordinate

	AND     CL,07H			;Compute which bit in a byte
	MOV     AL,80H			;and use it to rotate mask into position
	ROR     AL,CL
	MOV     CL,AL			;Keep mask in CL

; Return address of bit in ES:BX, mask in CL
	mov	ax,MGA_SEG
	mov	es,ax
	RET
Get_Addr_HGC ENDP

; ************************************************************************

KBD_SETUP PROC NEAR
	RETN
KBD_SETUP ENDP

KBD_RESET PROC NEAR
	RETN
KBD_RESET ENDP

; ************************************************************************

IFDEF DEBUG
SHOWMAXCOL PROC NEAR
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	 PUSH	AX
	  MOV	AL,'M'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'a'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'x'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'c'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'o'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'l'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'o'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'r'
	  CALL	NEAR PTR PRINT_ONE_CHAR
	  MOV	AL,'='
	  CALL	NEAR PTR PRINT_ONE_CHAR
	 POP	AX

	 mov	al,max_color		; CH = mode #
	 PUSH	AX
	  SHR	AL,1			; OUTPUT HIGH NYBBLE
	  SHR	AL,1
	  SHR	AL,1
	  SHR	AL,1
	  ADD	AL,'0'
	  cmp	al,'9'
	  jle	gm_hx
	  add	al,7			; MAKE 10 -> 'A'
gm_hx:
	  CALL	NEAR PTR PRINT_ONE_CHAR
	 POP	AX

	 AND	AL,0FH			; OUTPUT LOW NYBBLE
	 ADD	AL,'0'
	 cmp	al,'9'
	 jle	gm_hy
	 add	al,7			; MAKE 10 -> 'A'
gm_hy:
	 CALL	NEAR PTR PRINT_ONE_CHAR

	 MOV	AL,13
	 CALL	NEAR PTR PRINT_ONE_CHAR
	 MOV	AL,10
	 CALL	NEAR PTR PRINT_ONE_CHAR
	POP	DX
	POP	CX
	POP	BX
	POP	AX

	RETN
SHOWMAXCOL ENDP
ENDIF


; ---------------- E N D   P R O G R A M -------------------

_TEXT	ENDS
	END
